con
  right  = %0000_0001
  left   = %0000_0010
  down   = %0000_0100
  up     = %0000_1000
  start  = %0001_0000
  select = %0010_0000
  b      = %0100_0000
  a      = %1000_0000

con
  clock  = 3
  latch  = 4
  data_0 = 5
  data_1 = 6

var
 byte gp_0
 byte gp_1
 byte gp_combined

pub update
  dira[clock]~~
  dira[latch]~~
  dira[data_0]~
  dira[data_1]~

  outa[latch]~
  outa[clock]~

  outa[latch]~~ 
  outa[latch]~

  gp_0 := ina[data_0]
  gp_1 := ina[data_1] 

  repeat 7
    outa[clock]~~
    gp_0 <<= 1
    gp_1 <<= 1
    outa[clock]~

    gp_0 |= ina[data_0]
    gp_1 |= ina[data_1]

  !gp_0
  !gp_1
  if gp_0 == $ff
    gp_0 := 0
  if gp_1 == $ff
    gp_1 := 0
  gp_combined := gp_0 | gp_1
     

pub player_0(button_to_check)
  return gp_0 & button_to_check

pub player_1(button_to_check)
  return gp_1 & button_to_check

pub combined(button_to_check)
  return gp_combined & button_to_check
